diff --git a/README.lex b/README.lex
new file mode 100644
index 0000000..ac6e114
--- /dev/null
+++ b/README.lex
@@ -0,0 +1,2 @@
+JAVA_HOME=/usr/local/soylatte16-amd64
+PATH=/Users/spoon/java/expannots/langtools/dist/bin:$JAVA_HOME/bin:$PATH
diff --git a/checkers/src/checkers/units/AnnotationInterpreter.java b/checkers/src/checkers/units/AnnotationInterpreter.java
new file mode 100644
index 0000000..18fa7d4
--- /dev/null
+++ b/checkers/src/checkers/units/AnnotationInterpreter.java
@@ -0,0 +1,291 @@
+package checkers.units;
+
+import static checkers.units.CheckerDimension.WILDCARD;
+import static java.util.Collections.singletonList;
+import checkers.types.AnnotatedTypeMirror;
+import checkers.units.CheckerDimension.*;
+import checkers.units.model.Dimension;
+import checkers.units.quals.Dim;
+import checkers.util.*;
+import checkers.util.AnnotationUtils.AnnotationBuilder;
+import com.sun.tools.javac.util.List;
+import com.sun.source.tree.*;
+import com.sun.tools.javac.code.Symbol;
+import com.sun.tools.javac.processing.JavacProcessingEnvironment;
+import com.sun.tools.javac.tree.TreeMaker;
+import com.sun.tools.javac.tree.JCTree.JCExpression;
+
+import java.util.*;
+
+import javax.annotation.processing.ProcessingEnvironment;
+import javax.lang.model.element.*;
+import javax.lang.model.type.TypeMirror;
+import javax.lang.model.util.*;
+
+/**
+ * This class converts {@link checkers.units.quals.Dim} annotations to and from
+ * instances of {@link CheckerDimension}.
+ */
+public class AnnotationInterpreter {
+    /**
+     * An exception indicating than an annotation is not a valid dimension.
+     */
+    public static class InvalidAnnotation extends Exception {
+	public InvalidAnnotation(String message) {
+	    super(message);
+	}
+    }
+
+    private final AnnotationUtils annoFactory;
+    private final Elements elements;
+    private final TreeMaker treeMaker;
+    private final Types types;
+    private final ProcessingEnvironment env;
+
+    public AnnotationInterpreter(ProcessingEnvironment env) {
+	this.env = env;
+	this.elements = env.getElementUtils();
+	this.types = env.getTypeUtils();
+	this.annoFactory = AnnotationUtils.getInstance(env);
+	/**
+	 * TODO(spoon) The checker framework needs to have an abstraction for
+	 * tree making.
+	 */
+	this.treeMaker = TreeMaker.instance(((JavacProcessingEnvironment) env)
+		.getContext());
+    }
+
+    public CheckerDimension interpretAsDimension(
+	    AnnotatedTypeMirror annotatedType) throws InvalidAnnotation {
+	return interpretAsDimension(annotatedType.getAnnotation(Dim.class
+		.getCanonicalName()));
+    }
+
+    /**
+     * Convert an annotation to a dimension. Converts <code>null</code> to the
+     * wildcard dimension.
+     */
+    public CheckerDimension interpretAsDimension(AnnotationMirror annot)
+	    throws InvalidAnnotation {
+
+	if (annot == null) {
+	    return WILDCARD;
+	}
+	assert (((TypeElement) annot.getAnnotationType().asElement())
+		.getQualifiedName().toString()
+		.equals("checkers.units.qual.Dim"));
+
+	Map<? extends ExecutableElement, ? extends AnnotationValue> annotValues = annot
+		.getElementValues();
+	assert (annotValues.size() == 1);
+	Object annotValue = annotValues.entrySet().iterator().next().getValue()
+		.getValue();
+	if (annotValue instanceof ExpressionTree) {
+	    return interpretAsDimension((ExpressionTree) annotValue);
+	}
+	return null;
+
+    }
+
+    /**
+     * Check whether a method symbol corresponds to
+     * {@link Dimension#div(Dimension)}.
+     */
+    public boolean isDimensionDiv(ExecutableElement methodSymbol) {
+	return isMethod(methodSymbol, Dimension.class, "div", Dimension.class);
+    }
+
+    /**
+     * Check whether <code>methodSymbol</code> specifies the method named
+     * <code>methodName</code> in class <code>methodClass</code>, with parameter
+     * type <code>paramClass</code>
+     */
+    public boolean isMethod(ExecutableElement methodSymbol,
+	    Class<?> methodClass, String methodName, Class<?> paramClass) {
+	if (methodSymbol == null) {
+	    return false;
+	}
+	if (!(methodSymbol.getEnclosingElement() instanceof TypeElement)) {
+	    return false;
+	}
+
+	String methodClassName = methodClass.getCanonicalName();
+	String paramClassName = paramClass.getCanonicalName();
+
+	TypeElement methodClassSymbol = (TypeElement) methodSymbol
+		.getEnclosingElement();
+	if (methodName.equals(methodSymbol.getSimpleName().toString())
+		&& methodClassName.equals(methodClassSymbol.getQualifiedName()
+			.toString())
+		&& methodSymbol.getParameters().size() == 1) {
+	    TypeMirror paramType = methodSymbol.getParameters().get(0).asType();
+	    Element paramTypeElement = types.asElement(paramType);
+	    if (paramTypeElement instanceof TypeElement) {
+		if (((TypeElement) paramTypeElement).getQualifiedName()
+			.toString().equals(paramClassName)) {
+		    return true;
+		}
+	    }
+	}
+
+	return false;
+    }
+
+    /**
+     * Convert a dimension back to an annotation.
+     */
+    public AnnotationMirror makeAnnotationFor(CheckerDimension dimension) {
+	ExpressionTree tree = makeTreeFor(dimension);
+	if (tree == null) {
+	    return null;
+	}
+	AnnotationBuilder annotBuilder = new AnnotationBuilder(env, Dim.class
+		.getCanonicalName());
+
+	annotBuilder.setValue("value", tree);
+	return annotBuilder.build();
+    }
+
+    /**
+     * Look up a method in the given class, with the given name, and whose sole
+     * argument has a type with the given class.
+     */
+    private Symbol lookupMethod(Class<Dimension> enclosingClazz, String name,
+	    Class<Dimension> argClazz) {
+
+	Name clazzName = elements.getName(enclosingClazz.getCanonicalName());
+	Name elementName = elements.getName(name);
+	Name argName = elements.getName(argClazz.getCanonicalName());
+
+	TypeElement typeElement = elements.getTypeElement(clazzName);
+	for (Element elem : elements.getAllMembers(typeElement)) {
+	    if (elem.getSimpleName().equals(elementName)) {
+		if (elem instanceof ExecutableElement) {
+		    ExecutableElement methodElem = (ExecutableElement) elem;
+		    if (methodElem.getParameters().size() == 1) {
+			TypeMirror methodArgType = methodElem.getParameters()
+				.get(0).asType();
+			Element methodArgTypeElement = types
+				.asElement(methodArgType);
+			if (methodArgTypeElement instanceof TypeElement) {
+			    if (((TypeElement) methodArgTypeElement)
+				    .getQualifiedName().equals(argName)) {
+				return (Symbol) elem;
+			    }
+			}
+		    }
+		}
+	    }
+	}
+	// TODO(spoon) there must be an internal processor exception? If
+	// not, make one for the units checker
+	throw new RuntimeException("Could not find member " + name
+		+ " in type " + clazzName);
+    }
+
+    /**
+     * Look up a field in the program being compiled whose name is
+     * <code>name</code> and enclosing class is <code>clazz</code>.
+     */
+    private Symbol lookupField(Class<Dimension> clazz, String name) {
+	String clazzName = clazz.getCanonicalName();
+	TypeElement typeElement = elements.getTypeElement(clazzName);
+	Name elementName = elements.getName(name);
+	for (Element elem : elements.getAllMembers(typeElement)) {
+	    if (elem.getSimpleName().equals(elementName)) {
+		return (Symbol) elem;
+	    }
+	}
+	// TODO(spoon) there must be an internal processor exception? If
+	// not, make one for the units checker
+	throw new RuntimeException("Could not find member " + name
+		+ " in type " + clazzName);
+    }
+
+    private CheckerDimension interpretAsDimension(ExpressionTree expr)
+	    throws InvalidAnnotation {
+	// check for a raw field reference
+	Element element = InternalUtils.symbol(expr);
+	if (element != null && (element instanceof VariableElement)) {
+	    // TODO(spoon): also check that the field is a valid Dimension
+	    // holder.
+	    // It must be a static, final, field
+	    return new FieldDimension((VariableElement) element);
+	}
+
+	// check for a call to Dimension.times or Dimension.div
+	if (expr instanceof MethodInvocationTree) {
+	    MethodInvocationTree methodInvocation = (MethodInvocationTree) expr;
+	    ExpressionTree methodSelect = methodInvocation.getMethodSelect();
+	    ExecutableElement methodSymbol = (ExecutableElement) InternalUtils
+		    .symbol(methodSelect);
+	    if (methodSelect instanceof MemberSelectTree
+		    && isDimensionDiv(methodSymbol)) {
+		MemberSelectTree methodSelectAsSelect = (MemberSelectTree) methodSelect;
+		CheckerDimension left = interpretAsDimension(methodSelectAsSelect
+			.getExpression());
+		CheckerDimension right = interpretAsDimension(methodInvocation
+			.getArguments().get(0));
+		return left.div(right);
+	    }
+	}
+
+	throw new InvalidAnnotation("Annotation not in a valid dimension form");
+    }
+
+    private JCExpression makeTreeFor(CheckerDimension dim) {
+	final JCExpression[] result = new JCExpression[1];
+	dim.accept(new Visitor() {
+	    @Override
+	    public void visitCompound(CompoundDimension dim) {
+		// first do the numerator
+		if (dim.getNumer().isEmpty()) {
+		    result[0] = makeTreeFor(ScalarDimension.SCALAR);
+		} else {
+		    result[0] = makeTreeFor(dim.getNumer().get(0));
+		    boolean first = true;
+		    for (FieldDimension d : dim.getNumer()) {
+			if (first) {
+			    first = false;
+			} else {
+			    Symbol dimTimesDimSymbol = lookupMethod(
+				    Dimension.class, "times", Dimension.class);
+			    JCExpression selectTimes = treeMaker.Select(
+				    result[0], dimTimesDimSymbol);
+			    List<JCExpression> noTypeArgs = List.nil();
+			    result[0] = treeMaker.Apply(noTypeArgs,
+				    selectTimes, List.of(makeTreeFor(d)));
+			}
+		    }
+		}
+
+		for (FieldDimension d : dim.getDenom()) {
+		    Symbol dimDivDimSymbol = lookupMethod(Dimension.class,
+			    "div", Dimension.class);
+		    JCExpression selectDiv = treeMaker.Select(result[0],
+			    dimDivDimSymbol);
+		    List<JCExpression> noTypeArgs = List.nil();
+		    result[0] = treeMaker.Apply(noTypeArgs, selectDiv, List
+			    .of(makeTreeFor(d)));
+		}
+	    }
+
+	    @Override
+	    public void visitField(FieldDimension dim) {
+		result[0] = treeMaker.Ident((Symbol) dim.getField());
+	    }
+
+	    @Override
+	    public void visitScalar(ScalarDimension dim) {
+		Symbol scalarSymbol = lookupField(Dimension.class, "SCALAR");
+		result[0] = treeMaker.Ident(scalarSymbol);
+	    }
+
+	    @Override
+	    public void visitWildcard(WildcardDimension dim) {
+		result[0] = null;
+	    }
+	});
+	return result[0];
+    }
+}
diff --git a/checkers/src/checkers/units/CheckerDimension.java b/checkers/src/checkers/units/CheckerDimension.java
new file mode 100644
index 0000000..d225cd6
--- /dev/null
+++ b/checkers/src/checkers/units/CheckerDimension.java
@@ -0,0 +1,271 @@
+package checkers.units;
+
+import checkers.units.model.UnitsModelUtils;
+
+import java.util.*;
+
+import javax.lang.model.element.VariableElement;
+
+/**
+ * A checker dimension is a dimension as represented inside the
+ * {@link UnitsChecker}.
+ */
+abstract class CheckerDimension {
+    public static class CompoundDimension extends CheckerDimension {
+	private final List<FieldDimension> denom;
+	private final List<FieldDimension> numer;
+
+	CompoundDimension(List<FieldDimension> numer, List<FieldDimension> denom) {
+	    this.numer = numer;
+	    this.denom = denom;
+	}
+
+	@Override
+	public void accept(Visitor visitor) {
+	    visitor.visitCompound(this);
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+	    if (!(obj instanceof CompoundDimension)) {
+		return false;
+	    }
+	    CompoundDimension that = (CompoundDimension) obj;
+	    return isPermutation(numer, that.getNumer())
+		    && isPermutation(denom, that.getDenom());
+	}
+
+	@Override
+	public List<FieldDimension> getDenom() {
+	    return denom;
+	}
+
+	@Override
+	public List<FieldDimension> getNumer() {
+	    return numer;
+	}
+
+    }
+
+    /**
+     * A simple dimension defined by reference to a static field.
+     */
+    public static class FieldDimension extends CheckerDimension {
+	private final VariableElement field;
+
+	public FieldDimension(VariableElement field) {
+	    this.field = field;
+	}
+
+	@Override
+	public void accept(Visitor visitor) {
+	    visitor.visitField(this);
+	}
+
+	@Override
+	public boolean equals(Object obj) {
+	    if (!(obj instanceof FieldDimension)) {
+		return false;
+	    }
+	    FieldDimension that = (FieldDimension) obj;
+	    return sameField(field, that.getField());
+	}
+
+	public VariableElement getField() {
+	    return field;
+	}
+
+	@Override
+	public int hashCode() {
+	    return field.getSimpleName().hashCode() * 17
+		    + field.getEnclosingElement().hashCode();
+	}
+
+	@Override
+	public String toString() {
+	    return field.toString();
+	}
+
+	@Override
+	protected List<FieldDimension> getDenom() {
+	    return NO_DIMENSIONS;
+	}
+
+	@Override
+	protected List<FieldDimension> getNumer() {
+	    return Collections.singletonList(this);
+	}
+    }
+
+    public static class ScalarDimension extends CheckerDimension {
+
+	@Override
+	public void accept(Visitor visitor) {
+	    visitor.visitScalar(this);
+	}
+
+	@Override
+	protected List<FieldDimension> getDenom() {
+	    return NO_DIMENSIONS;
+	}
+
+	@Override
+	protected List<FieldDimension> getNumer() {
+	    return NO_DIMENSIONS;
+	}
+    }
+
+    public interface Visitor {
+	void visitCompound(CompoundDimension dim);
+
+	void visitField(FieldDimension dim);
+
+	void visitScalar(ScalarDimension dim);
+
+	void visitWildcard(WildcardDimension dim);
+    }
+
+    /**
+     * A wildcard dimension represents a completely unknown dimension, in the
+     * gradual-typing style.
+     */
+    public static class WildcardDimension extends CheckerDimension {
+	@Override
+	public void accept(Visitor visitor) {
+	    visitor.visitWildcard(this);
+	}
+
+	@Override
+	protected List<FieldDimension> getDenom() {
+	    throw new AssertionError("Should not be called");
+	}
+
+	@Override
+	protected List<FieldDimension> getNumer() {
+	    throw new AssertionError("Should not be called");
+	}
+    }
+
+    public static ScalarDimension SCALAR = new ScalarDimension();
+
+    public static WildcardDimension WILDCARD = new WildcardDimension();
+
+    @SuppressWarnings("unchecked")
+    private static final List<FieldDimension> NO_DIMENSIONS = Collections.EMPTY_LIST;
+
+    public static CheckerDimension normalize(List<FieldDimension> numer,
+	    List<FieldDimension> denom) {
+
+	List<FieldDimension> nums = new ArrayList<FieldDimension>(numer);
+	List<FieldDimension> dens = new ArrayList<FieldDimension>(denom);
+
+	for (FieldDimension d : denom) {
+	    if (nums.contains(d)) {
+		nums.remove(d);
+		dens.remove(d);
+	    }
+	}
+
+	nums = UnitsModelUtils.roughSort(nums);
+	dens = UnitsModelUtils.roughSort(dens);
+
+	if (nums.isEmpty() && dens.isEmpty()) {
+	    return SCALAR;
+	}
+	if (nums.size() == 1 && dens.isEmpty()) {
+	    return nums.get(0);
+	}
+	return new CompoundDimension(nums, dens);
+    }
+
+    private static <T> boolean isPermutation(List<T> list1, List<T> list2) {
+	if (list1.size() != list2.size()) {
+	    return false;
+	}
+
+	List<T> list2left = new ArrayList<T>(list2);
+	for (T x : list1) {
+	    if (!list2left.remove(x)) {
+		return false;
+	    }
+	}
+	return true;
+    }
+
+    private static boolean sameField(VariableElement field1,
+	    VariableElement field2) {
+	/*
+	 * For some reason, the Javac ClassReader neither hash-conses field
+	 * reference symbols nor implements equals() for them. Thus, compare the
+	 * classes and compare the names.
+	 */
+	return field1.getEnclosingElement()
+		.equals(field2.getEnclosingElement())
+		&& field1.getSimpleName().equals(field2.getSimpleName());
+    }
+
+    protected CheckerDimension() {
+    }
+
+    public abstract void accept(Visitor visitor);
+
+    /**
+     * Give the result of adding or subtracting measures with the specified
+     * dimensions. Returns <code>null</code> if the dimensions are incompatible.
+     */
+    public CheckerDimension combine(CheckerDimension that) {
+	if (this == WILDCARD) {
+	    return that;
+	}
+	if (that == WILDCARD) {
+	    return this;
+	}
+	if (isAssignableTo(that)) {
+	    return that;
+	}
+	return null;
+    }
+
+    public CheckerDimension div(CheckerDimension that) {
+	if (this == WILDCARD || that == WILDCARD) {
+	    return WILDCARD;
+	}
+	List<FieldDimension> newNumer = new ArrayList<FieldDimension>();
+	newNumer.addAll(getNumer());
+	newNumer.addAll(that.getDenom());
+
+	List<FieldDimension> newDenom = new ArrayList<FieldDimension>();
+	newDenom.addAll(getDenom());
+	newDenom.addAll(that.getNumer());
+
+	return normalize(newNumer, newDenom);
+    }
+
+    public boolean isAssignableTo(CheckerDimension that) {
+	if (this == WILDCARD || that == WILDCARD) {
+	    return true;
+	}
+
+	return isPermutation(getNumer(), that.getNumer())
+		&& isPermutation(getDenom(), that.getDenom());
+    }
+
+    public CheckerDimension times(CheckerDimension that) {
+	if (this == WILDCARD || that == WILDCARD) {
+	    return WILDCARD;
+	}
+	List<FieldDimension> newNumer = new ArrayList<FieldDimension>();
+	newNumer.addAll(getNumer());
+	newNumer.addAll(that.getNumer());
+
+	List<FieldDimension> newDenom = new ArrayList<FieldDimension>();
+	newDenom.addAll(getDenom());
+	newDenom.addAll(that.getDenom());
+
+	return normalize(newNumer, newDenom);
+    }
+
+    protected abstract List<FieldDimension> getDenom();
+
+    protected abstract List<FieldDimension> getNumer();
+}
diff --git a/checkers/src/checkers/units/UnitsChecker.java b/checkers/src/checkers/units/UnitsChecker.java
new file mode 100644
index 0000000..cf22d21
--- /dev/null
+++ b/checkers/src/checkers/units/UnitsChecker.java
@@ -0,0 +1,169 @@
+package checkers.units;
+
+import checkers.basetype.BaseTypeChecker;
+import checkers.quals.TypeQualifiers;
+import checkers.source.Result;
+import checkers.types.*;
+import checkers.units.AnnotationInterpreter.InvalidAnnotation;
+import checkers.units.model.Measure;
+import checkers.units.quals.Dim;
+import checkers.util.InternalUtils;
+
+import com.sun.source.tree.*;
+
+import java.util.*;
+
+import javax.lang.model.element.*;
+import javax.lang.model.type.*;
+
+@TypeQualifiers( { Dim.class })
+public class UnitsChecker extends BaseTypeChecker {
+    public class UnitsQualifierHierarchy extends QualifierHierarchy {
+	private final AnnotationInterpreter annotInterp = new AnnotationInterpreter(
+		getProcessingEnvironment());
+
+	@Override
+	public AnnotationMirror getRootAnnotation() {
+	    // There isn't an ultimate root type in this system
+	    return null;
+	}
+
+	@Override
+	public Set<Name> getTypeQualifiers() {
+	    return Collections.singleton(env.getElementUtils().getName(
+		    Dim.class.getName()));
+	}
+
+	@Override
+	public boolean isSubtype(AnnotationMirror a1, AnnotationMirror a2) {
+	    CheckerDimension dim1;
+	    CheckerDimension dim2;
+	    try {
+		dim1 = annotInterp.interpretAsDimension(a1);
+	    } catch (InvalidAnnotation e) {
+		// TODO(spoon) how to report this to the user?
+		return false;
+	    }
+	    try {
+		dim2 = annotInterp.interpretAsDimension(a2);
+	    } catch (InvalidAnnotation e) {
+		return false;
+	    }
+
+	    return dim1.isAssignableTo(dim2);
+	}
+
+	@Override
+	public AnnotationMirror leastUpperBound(AnnotationMirror a1,
+		AnnotationMirror a2) {
+	    // TODO(spoon)
+	    return a1;
+	}
+
+    }
+
+    public class UnitsTypeFactory extends AnnotatedTypeFactory {
+	private final AnnotationInterpreter annotInterp = new AnnotationInterpreter(
+		getProcessingEnvironment());
+
+	public UnitsTypeFactory(CompilationUnitTree root) {
+	    super(UnitsChecker.this, root);
+	}
+
+	@Override
+	public void annotateImplicit(Tree tree, AnnotatedTypeMirror type) {
+	    try {
+		if (tree instanceof MethodInvocationTree) {
+		    /*
+		     * In a call to Unit.times(double), the units are the same
+		     * as the receiver
+		     */
+		    if (tree.getKind() == Tree.Kind.METHOD_INVOCATION) {
+			MethodInvocationTree treeInvoke = (MethodInvocationTree) tree;
+			MemberSelectTree method = (MemberSelectTree) treeInvoke
+				.getMethodSelect();
+			ExecutableElement methodSymbol = (ExecutableElement) InternalUtils
+				.symbol(method);
+			TypeElement methodClassSymbol = (TypeElement) methodSymbol
+				.getEnclosingElement();
+			if ("times".equals(methodSymbol.getSimpleName()
+				.toString())
+				&& "checkers.units.model.Unit"
+					.equals(methodClassSymbol
+						.getQualifiedName().toString())
+				&& methodSymbol.getParameters().size() == 1) {
+			    TypeMirror paramType = getAnnotatedType(
+				    methodSymbol.getParameters().get(0))
+				    .getUnderlyingType();
+			    if (paramType.getKind() == TypeKind.DOUBLE) {
+				AnnotatedTypeMirror receiverType = getAnnotatedType(method
+					.getExpression());
+				type.addAnnotations(receiverType
+					.getAnnotations());
+				return;
+			    }
+			}
+
+			if (annotInterp.isMethod(methodSymbol, Measure.class,
+				"div", Measure.class)) {
+			    CheckerDimension left = annotInterp
+				    .interpretAsDimension(getAnnotatedType(method
+					    .getExpression()));
+			    CheckerDimension right = annotInterp
+				    .interpretAsDimension(getAnnotatedType(treeInvoke
+					    .getArguments().get(0)));
+			    CheckerDimension result = left.div(right);
+			    type.addAnnotation(makeAnnotationFor(result));
+			}
+
+			if (annotInterp.isMethod(methodSymbol, Measure.class,
+				"plus", Measure.class)
+				|| annotInterp.isMethod(methodSymbol,
+					Measure.class, "minus", Measure.class)) {
+			    CheckerDimension left = annotInterp
+				    .interpretAsDimension(getAnnotatedType(method
+					    .getExpression()));
+			    CheckerDimension right = annotInterp
+				    .interpretAsDimension(getAnnotatedType(treeInvoke
+					    .getArguments().get(0)));
+			    CheckerDimension result = left;
+			    if (left == CheckerDimension.WILDCARD) {
+				// If one side is a wildcard, use the other side.
+				// If both are wildcards, then use wildcard.
+				result = right;
+			    }
+			    if (!left.isAssignableTo(right)) {
+				// TODO(spoon) localize this error
+				report(Result.failure(
+					"Incompatible units: %s vs. %s", left,
+					right), tree);
+				result = CheckerDimension.WILDCARD;
+			    }
+			    AnnotationMirror resultAnnot = makeAnnotationFor(result);
+			    if (resultAnnot != null) {
+				type.addAnnotation(resultAnnot);
+			    }
+			}
+		    }
+		}
+	    } catch (InvalidAnnotation e) {
+		// Quietly do nothing. The error should be caught and reported
+		// elsewhere.
+	    }
+	}
+
+	private AnnotationMirror makeAnnotationFor(CheckerDimension dim) {
+	    return annotInterp.makeAnnotationFor(dim);
+	}
+    }
+
+    @Override
+    public AnnotatedTypeFactory createFactory(CompilationUnitTree root) {
+	return new UnitsTypeFactory(root);
+    }
+
+    @Override
+    public QualifierHierarchy createQualifierHierarchy() {
+	return new UnitsQualifierHierarchy();
+    }
+}
diff --git a/checkers/src/checkers/units/model/Dimension.java b/checkers/src/checkers/units/model/Dimension.java
new file mode 100644
index 0000000..a8e4cdb
--- /dev/null
+++ b/checkers/src/checkers/units/model/Dimension.java
@@ -0,0 +1,230 @@
+package checkers.units.model;
+
+import java.util.*;
+
+/**
+ * The dimension of a unit, such as length, time, or length divided by time. Two
+ * units are compatible if their dimension is the same.
+ */
+public abstract class Dimension {
+    /**
+     * A simple dimension is the most atomic element of a compound dimension.
+     * Instantiate this class to create a new kind of dimension for a particular
+     * application. Simple dimensions can be compared with object equality.
+     */
+    public static class SimpleDimension extends Dimension {
+	private final String name;
+
+	public SimpleDimension(String name) {
+	    this.name = name;
+	}
+
+	@Override
+	public String toString() {
+	    return name;
+	}
+
+	@Override
+	protected List<SimpleDimension> getDenominator() {
+	    return NO_DIMENSIONS;
+	}
+
+	@Override
+	protected List<SimpleDimension> getNumerator() {
+	    return singleton(this);
+	}
+    }
+
+    static class CompoundDimension extends Dimension {
+	List<SimpleDimension> denom;
+
+	List<SimpleDimension> numer;
+
+	public CompoundDimension(List<SimpleDimension> numer,
+		List<SimpleDimension> denom) {
+	    assert (numer.size() != 0 || denom.size() != 0);
+	    assert (denom.size() > 0 || numer.size() > 1);
+	    this.numer = numer;
+	    this.denom = denom;
+	}
+
+	@Override
+	public boolean equals(Object object) {
+	    if (!(object instanceof CompoundDimension)) {
+		return false;
+	    }
+	    CompoundDimension that = (CompoundDimension) object;
+	    return (sameElements(this.getNumerator(), that.getNumerator()) && sameElements(
+		    this.getDenominator(), that.getDenominator()));
+	}
+
+	@Override
+	public List<SimpleDimension> getDenominator() {
+	    return denom;
+	}
+
+	@Override
+	public List<SimpleDimension> getNumerator() {
+	    return numer;
+	}
+
+	@Override
+	public int hashCode() {
+	    int code = 31;
+	    for (SimpleDimension dim : numer) {
+		code = code * 17 + dim.hashCode();
+	    }
+	    for (SimpleDimension dim : denom) {
+		code = code * 17 + dim.hashCode();
+	    }
+	    return code;
+	}
+
+	@Override
+	public String toString() {
+	    StringBuilder sb = new StringBuilder();
+	    if (numer.size() == 0) {
+		sb.append("1");
+	    } else {
+		boolean first = true;
+		for (SimpleDimension dim : numer) {
+		    if (first) {
+			first = false;
+		    } else {
+			sb.append("*");
+		    }
+		    sb.append(dim);
+		}
+	    }
+	    if (denom.size() > 0) {
+		sb.append("/");
+		if (denom.size() > 1) {
+		    sb.append("(");
+		}
+		boolean first = true;
+		for (SimpleDimension dim : denom) {
+		    if (first) {
+			first = false;
+		    } else {
+			sb.append("*");
+		    }
+		    sb.append(dim);
+		}
+		if (denom.size() > 1) {
+		    sb.append(")");
+		}
+	    }
+	    return sb.toString();
+	}
+
+	private boolean sameElements(List<SimpleDimension> list1,
+		List<SimpleDimension> list2) {
+	    if (list1.size() != list2.size()) {
+		return false;
+	    }
+	    List<SimpleDimension> list2left = new ArrayList<SimpleDimension>(
+		    list2);
+	    for (SimpleDimension dim1 : list1) {
+		if (!list2left.contains(dim1)) {
+		    return false;
+		}
+		list2left.remove(dim1);
+	    }
+	    assert list2left.isEmpty();
+	    return true;
+	}
+    }
+
+    private static class ScalarDimension extends Dimension {
+	@Override
+	public String toString() {
+	    return "ScalarDimension";
+	}
+
+	@Override
+	protected List<SimpleDimension> getDenominator() {
+	    return NO_DIMENSIONS;
+	}
+
+	@Override
+	protected List<SimpleDimension> getNumerator() {
+	    return NO_DIMENSIONS;
+	}
+    }
+
+    @SuppressWarnings("unchecked")
+    private static final List<SimpleDimension> NO_DIMENSIONS = Collections.EMPTY_LIST;
+
+    /**
+     * The dimension of scalar values.
+     */
+    public static final Dimension SCALAR = new ScalarDimension();
+
+    private static Dimension normalize(List<SimpleDimension> numer,
+	    List<SimpleDimension> denom) {
+	List<SimpleDimension> nums = new ArrayList<SimpleDimension>(numer);
+	List<SimpleDimension> dens = new ArrayList<SimpleDimension>(denom);
+
+	for (SimpleDimension d : denom) {
+	    if (nums.contains(d)) {
+		nums.remove(d);
+		dens.remove(d);
+	    }
+	}
+
+	nums = UnitsModelUtils.roughSort(nums);
+	dens = UnitsModelUtils.roughSort(dens);
+
+	if (nums.isEmpty() && dens.isEmpty()) {
+	    return SCALAR;
+	}
+	if (nums.size() == 1 && dens.isEmpty()) {
+	    return nums.get(0);
+	}
+	return new CompoundDimension(nums, dens);
+    }
+
+    private static <T> List<T> singleton(T elem) {
+	return Collections.singletonList(elem);
+    }
+
+    public Dimension div(Dimension that) {
+	List<SimpleDimension> newnum = new ArrayList<SimpleDimension>();
+	newnum.addAll(this.getNumerator());
+	newnum.addAll(that.getDenominator());
+	List<SimpleDimension> newden = new ArrayList<SimpleDimension>();
+	newden.addAll(this.getDenominator());
+	newden.addAll(that.getNumerator());
+
+	return normalize(newnum, newden);
+    }
+
+    public Dimension exp(int exponent) {
+	List<SimpleDimension> newnum = new ArrayList<SimpleDimension>();
+	for (int i = 0; i < exponent; i++) {
+	    newnum.addAll(getNumerator());
+	}
+	List<SimpleDimension> newden = new ArrayList<SimpleDimension>();
+	for (int i = 0; i < exponent; i++) {
+	    newden.addAll(getDenominator());
+	}
+
+	return normalize(newnum, newden);
+
+    }
+
+    public Dimension times(Dimension that) {
+	List<SimpleDimension> newnum = new ArrayList<SimpleDimension>();
+	newnum.addAll(this.getNumerator());
+	newnum.addAll(that.getNumerator());
+	List<SimpleDimension> newden = new ArrayList<SimpleDimension>();
+	newden.addAll(this.getDenominator());
+	newden.addAll(that.getDenominator());
+
+	return normalize(newnum, newden);
+    }
+
+    protected abstract List<SimpleDimension> getDenominator();
+
+    protected abstract List<SimpleDimension> getNumerator();
+}
diff --git a/checkers/src/checkers/units/model/IncompatibleUnitsError.java b/checkers/src/checkers/units/model/IncompatibleUnitsError.java
new file mode 100644
index 0000000..173670e
--- /dev/null
+++ b/checkers/src/checkers/units/model/IncompatibleUnitsError.java
@@ -0,0 +1,17 @@
+package checkers.units.model;
+
+import checkers.units.model.Unit;
+
+/**
+ * An exception indicating an attempt to perform arithmetic on incompatible
+ * units.
+ */
+public class IncompatibleUnitsError extends RuntimeException {
+    public IncompatibleUnitsError(String msg) {
+	super(msg);
+    }
+
+    public IncompatibleUnitsError(Unit unit1, Unit unit2) {
+	this("Incompatible units: " + unit1 + " vs. " + unit2);
+    }
+}
